SystemOrganization addCategory: #ConfigurationOfProfStef!

Object subclass: #ConfigurationOfProfStef
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfProfStef'!

!ConfigurationOfProfStef class methodsFor: 'private' stamp: 'LaurentLaffont 1/21/2010 09:01'!
bootstrapPackage: aString from: aPath 
	| repository version |
	repository := MCHttpRepository
				location: aPath
				user: ''
				password: ''.
	repository
		versionReaderForFileNamed: aString , '.mcz'
		do: [:reader | 
			version := reader version.
			version load.
			version workingCopy repositoryGroup addRepository: repository]! !

!ConfigurationOfProfStef class methodsFor: 'private' stamp: 'LaurentLaffont 1/21/2010 09:01'!
ensureMetacello
	"Bootstrap Gofer (if necessary), bootstrap ConfigurationOfMetacello (using old Gofer API), then load the latest 
	version of Metacello itself."

	Smalltalk at: #MetacelloProject ifAbsent: [
		Smalltalk at: #Gofer ifAbsent: [
			"Current version of Gofer from which to bootstrap - as of 1.0-beta.15"
			self bootstrapPackage: 'Gofer-lr.83' from: 'http://seaside.gemstone.com/ss/metacello' ].
		Smalltalk at: #Gofer ifPresent: [:goferClass | | gofer |
			gofer := goferClass new
				url: 'http://seaside.gemstone.com/ss/metacello';
				yourself.
			[ gofer addPackage: 'ConfigurationOfMetacello' ] on: Warning do: [:ex | ex resume ].
			gofer load ].
		"load latest version of Metacello, load a specific version if desired"
		(Smalltalk at: #ConfigurationOfMetacello) perform: #loadLatestVersion ]! !

!ConfigurationOfProfStef class methodsFor: 'metacello tool support' stamp: 'LaurentLaffont 1/21/2010 09:01'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfProfStef class methodsFor: 'metacello tool support' stamp: 'LaurentLaffont 1/21/2010 09:01'!
lastMetacelloVersionLoad
	"Answer the last version loaded and the list of packages loaded for that version."

	LastVersionLoad == nil ifTrue: [ LastVersionLoad := nil -> 'default' ].
	^LastVersionLoad! !

!ConfigurationOfProfStef class methodsFor: 'metacello tool support' stamp: 'LaurentLaffont 1/21/2010 09:01'!
metacelloVersion: versionString loads: anArrayOrString
	"Stash the last version loaded and the list of packages loaded for that version. The list
	 of packages will be used by the tools when doing 'Load Package Version'"

	LastVersionLoad := versionString -> anArrayOrString! !

!ConfigurationOfProfStef class methodsFor: 'accessing' stamp: 'LaurentLaffont 1/21/2010 09:01'!
project

	^self new project! !

!ConfigurationOfProfStef methodsFor: 'baselines' stamp: 'LaurentLaffont 1/21/2010 09:36'!
baseline10: spec 
	<version: '1.0-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.
	].
		
	spec for: #pharo do: [
		spec repository: 'http://www.squeaksource.com/ProfStef'.
		spec project: 'Shout' with: [
				spec
					className: 'ConfigurationOfShout';
					loads: #('Core' );
					file: 'ConfigurationOfShout';
					repository: 'http://www.squeaksource.com/MetacelloRepository' ].
		spec package: 'ProfStef'.
	]! !

!ConfigurationOfProfStef methodsFor: 'accessing' stamp: 'LaurentLaffont 1/21/2010 09:01'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		self class ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear.
		project ]! !

!ConfigurationOfProfStef methodsFor: 'versions' stamp: 'LaurentLaffont 1/21/2010 22:43'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline')>

	spec for: #common do: [
		spec blessing: #release.
		spec author: 'LaurentLaffont'.
		spec description: 'Release 1.0 of this project '.
	].
	
	spec for: #pharo do: [		
		spec project: 'Shout' with: '1.0'.
		spec package: 'ProfStef' with: 'ProfStef-LaurentLaffont.14'.
	]
			! !
